/* circles.cc
 * 1998/03/14
 * (c)Cipher AKA Jeff Weeks of Code X
 *
 * Contains standard filled and outline circle functions
 */

#include <iostream.h>
#include <stdlib.h>
#include "petal.h"
#include "circles.h"

void circle(int xc, int yc, int r, int c, Image *img = petal.default_image) {
  int x = 0, y = r, d = 2 * (1 - r);

  while(y >= 0) {
    putpixel(xc + x, yc + y, c, img);
    putpixel(xc + x, yc - y, c, img);
    putpixel(xc - x, yc + y, c, img);
    putpixel(xc - x, yc - y, c, img);
    if(d + y > 0) {
      y -= 1;
      d -= (2 * y /* * SCREEN_WIDTH / SCREEN_HEIGTH */ ) - 1;
    }
    if(x > d) {
      x += 1;
      d += (2 * x) + 1;
    }
  }
}

void filled_circle(int xc, int yc, int r, int c, Image *img = petal.default_image) {
  int x = 0, y = r, d = 2 * (1 - r);

  while(y >= 0) {
    //putpixel(xc + x, yc + y, c, img);
    //putpixel(xc + x, yc - y, c, img);
    //putpixel(xc - x, yc + y, c, img);
    //putpixel(xc - x, yc - y, c, img);
    hline(xc - x, xc + x, yc + y, c, img);
    hline(xc - x, xc + x, yc - y, c, img);
    if(d + y > 0) {
      y -= 1;
      d -= (2 * y /* * SCREEN_WIDTH / SCREEN_HEIGTH */ ) - 1;
    }
    if(x > d) {
      x += 1;
      d += (2 * x) + 1;
    }
  }
}
