/* colour.cc
 * 1997/09/09
 * (c)Cipher AKA Jeff Weeks of Code X
 *
 * Contains different portable routines for creating and
 * manipulating colour values.  Don't you just love these
 * colour functions?  Personally, I find a standard system
 * of representing colours in all colour depths much
 * more intuitive, that's why I went the 0.0 ... 1.0 route.
 */

#include	<iostream.h>
#include        <math.h>
#include	"petal.h"
#include	"colour.h"

unsigned long max_col;

int  colour8(float fr, float fg, float fb) {
  int r = (int)(fr * 256.0), g = (int)(fg * 256.0), b = (int)(fb * 256.0);
  int closest, c;
  int diff, i;

  closest = (int)sqrt( (r - petal.pal->r) * (r - petal.pal->r) +
                       (g - petal.pal->g) * (g - petal.pal->g) +
                       (b - petal.pal->b) * (b - petal.pal->b) );
  c = 0;
  for(i = 1; i <= 255; i++) {
    diff = (int)sqrt( (r - petal.pal[i].r) * (r - petal.pal[i].r) +
                      (g - petal.pal[i].g) * (g - petal.pal[i].g) +
                      (b - petal.pal[i].b) * (b - petal.pal[i].b) );
    if(diff < closest) {
      closest = diff;
      c = i;
    }
  }
  return c;
}

int  colour15(float fr, float fg, float fb) {
  int r, g, b;
  r = (int)(fr * BPP15_R_TOTAL);
  g = (int)(fg * BPP15_G_TOTAL);
  b = (int)(fb * BPP15_B_TOTAL);
  return (int)(r << BPP15_R_START) | (g << BPP15_G_START) | (b << BPP15_B_START);
}

int  colour16(float fr, float fg, float fb) {
  int r, g, b;
  r = (int)(fr * BPP16_R_TOTAL);
  g = (int)(fg * BPP16_G_TOTAL);
  b = (int)(fb * BPP16_B_TOTAL);
  return (int)(r << BPP16_R_START) | (g << BPP16_G_START) | (b << BPP16_B_START);
}

int  colour24(float fr, float fg, float fb) {
  int r, g, b;
  r = (int)(fr * BPP24_R_TOTAL);
  g = (int)(fg * BPP24_G_TOTAL);
  b = (int)(fb * BPP24_B_TOTAL);
  return (int)(r << BPP24_R_START) | (g << BPP24_G_START) | (b << BPP24_B_START);
}

int  colour32(float fr, float fg, float fb) {
  int r, g, b;
  r = (int)(fr * BPP32_R_TOTAL);
  g = (int)(fg * BPP32_G_TOTAL);
  b = (int)(fb * BPP32_B_TOTAL);
  return (int)(r << BPP32_R_START) | (g << BPP32_G_START) | (b << BPP32_B_START);
}
