#ifdef __DJGPP__

#include <dos.h>
#include <dpmi.h>
#include <go32.h>

#include "vesa.h"

VesaInfo card;
VesaModeInfo mode;
int bytes_per_line;
int bytes_per_pixel;
int curbank;
__dpmi_regs regs;

void get_mode_info(int mode, VesaModeInfo *mode_info) {
  __dpmi_regs regs;

  regs.x.ax = 0x4F01;                  // get vesa mode info
  regs.x.di = __tb & 0x0F;             // the offset of the transfer buffer
  regs.x.es = (__tb >> 4) & 0xFFFF;    // the segment of the transfer buffer
  regs.x.cx = mode;
  __dpmi_int(0x10, &regs);
  if(regs.h.ah) return;                 // we don't report the error yet..
  dosmemget(__tb, sizeof(*mode_info), mode_info);
}

#endif
